package com.girafi.waddles.client.model;

import com.girafi.waddles.entity.EntityAdeliePenguin;
import net.minecraft.client.model.ModelBase;
import net.minecraft.client.model.ModelRenderer;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.entity.Entity;
import net.minecraft.util.math.MathHelper;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

@SideOnly(Side.CLIENT)
public class ModelPenguin extends ModelBase {
    private ModelRenderer head;
    private ModelRenderer body;
    private ModelRenderer beak;
    private ModelRenderer flipperRight;
    private ModelRenderer flipperLeft;
    private ModelRenderer feetLeft;
    private ModelRenderer feetRight;
    private ModelRenderer tail;

    public ModelPenguin() {
        this.field_78090_t = 32;
        this.field_78089_u = 32;
        this.beak = new ModelRenderer(this, 18, 0);
        this.beak.func_78793_a(0.0F, 0.0F, 0.0F);
        this.beak.func_78790_a(-0.5F, -3.0F, -4.0F, 1, 2, 3, 0.0F);
        this.setRotateAngle(beak, 0.08726646259971647F, -0.0F, 0.0F);
        this.body = new ModelRenderer(this, 0, 9);
        this.body.func_78793_a(0.0F, 12.0F, 1.0F);
        this.body.func_78790_a(-2.5F, 0.0F, -2.0F, 5, 11, 5, 0.0F);
        this.feetRight = new ModelRenderer(this, 0, 25);
        this.feetRight.func_78793_a(-1.0F, 11.0F, 0.0F);
        this.feetRight.func_78790_a(-2.0F, 0.0F, -3.0F, 2, 1, 3, 0.0F);
        this.setRotateAngle(feetRight, 0.0F, 0.2617993877991494F, 0.0F);
        this.head = new ModelRenderer(this, 0, 0);
        this.head.func_78793_a(0.0F, 12.0F, 0.0F);
        this.head.func_78790_a(-2.0F, -4.0F, -2.0F, 4, 4, 5, 0.0F);
        this.tail = new ModelRenderer(this, 20, 20);
        this.tail.func_78793_a(0.0F, 11.0F, 3.0F);
        this.tail.func_78790_a(-1.5F, -1.0F, 0.0F, 3, 3, 1, 0.0F);
        this.setRotateAngle(tail, 1.2566370614359172F, 0.0F, 0.0F);
        this.flipperRight = new ModelRenderer(this, 20, 10);
        this.flipperRight.func_78793_a(-2.5F, 1.0F, 0.0F);
        this.flipperRight.func_78790_a(-1.0F, 0.0F, -1.0F, 1, 7, 3, 0.0F);
        this.setRotateAngle(flipperRight, 0.0F, 0.0F, 0.08726646259971647F);
        this.feetLeft = new ModelRenderer(this, 0, 25);
        this.feetLeft.field_78809_i = true;
        this.feetLeft.func_78793_a(1.0F, 11.0F, 0.0F);
        this.feetLeft.func_78790_a(0.0F, 0.0F, -3.0F, 2, 1, 3, 0.0F);
        this.setRotateAngle(feetLeft, 0.0F, -0.2617993877991494F, 0.0F);
        this.flipperLeft = new ModelRenderer(this, 20, 10);
        this.flipperLeft.field_78809_i = true;
        this.flipperLeft.func_78793_a(2.5F, 1.0F, 0.0F);
        this.flipperLeft.func_78790_a(0.0F, 0.0F, -1.0F, 1, 7, 3, 0.0F);
        this.setRotateAngle(flipperLeft, 0.0F, 0.0F, -0.08726646259971647F);
        this.head.func_78792_a(this.beak);
        this.body.func_78792_a(this.feetRight);
        this.body.func_78792_a(this.tail);
        this.body.func_78792_a(this.flipperRight);
        this.body.func_78792_a(this.feetLeft);
        this.body.func_78792_a(this.flipperLeft);
    }

    @Override
    public void func_78088_a(Entity entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw, float headPitch, float scale) {
        if (this.field_78091_s) {
            float f = 2.0F;
            GlStateManager.func_179094_E();
            GlStateManager.func_179109_b(0.0F, 6.0F * scale, 0.0F);
            this.head.func_78785_a(scale);
            GlStateManager.func_179121_F();
            GlStateManager.func_179094_E();
            GlStateManager.func_179152_a(1.4F / f, 1.0F / f, 1.2F / f);
            GlStateManager.func_179109_b(0.0F, 24.0F * scale, 0.0F);
            this.body.func_78785_a(scale);
            GlStateManager.func_179121_F();
        } else {
            this.head.func_78785_a(scale);
            this.body.func_78785_a(scale);
        }
    }

    private void setRotateAngle(ModelRenderer modelRenderer, float x, float y, float z) {
        modelRenderer.field_78795_f = x;
        modelRenderer.field_78796_g = y;
        modelRenderer.field_78808_h = z;
    }

    @Override
    public void func_78087_a(float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw, float headPitch, float scaleFactor, Entity entity) {
        EntityAdeliePenguin penguin = (EntityAdeliePenguin) entity;

        this.head.field_78795_f = headPitch * 0.017453292F;
        this.head.field_78796_g = netHeadYaw * 0.017453292F;
        this.head.field_78808_h = (MathHelper.func_76134_b(limbSwing * 1.3324F) * 1.4F * limbSwingAmount) / 6;
        this.body.field_78808_h = (MathHelper.func_76134_b(limbSwing * 1.3324F) * 1.4F * limbSwingAmount) / 6;
        this.feetRight.field_78795_f = MathHelper.func_76134_b(limbSwing * 1.3324F) * 1.2F * limbSwingAmount;
        this.feetLeft.field_78795_f = MathHelper.func_76134_b(limbSwing * 1.3324F + (float) Math.PI) * 1.2F * limbSwingAmount;
        this.flipperRight.field_78808_h = 0.08726646259971647F + (MathHelper.func_76134_b((float) penguin.rotationFlipper) * limbSwingAmount);
        this.flipperLeft.field_78808_h = -0.08726646259971647F + (MathHelper.func_76134_b((float) penguin.rotationFlipper + (float) Math.PI) * limbSwingAmount);
        this.tail.field_78796_g = MathHelper.func_76134_b(limbSwing * 0.6662F) * 1.4F * 1.4F * limbSwingAmount;

        //Roation angles when swimming
        //this.body.rotateAngleX = penguin.bodyRotation;

        /*this.flipperRight.rotateAngleX = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbSwingAmount * 0.5F; //TODO
        this.flipperLeft.rotateAngleX = MathHelper.cos(limbSwing * 0.6662F + (float) Math.PI) * 1.4F * limbSwingAmount * 0.5F;*/
    }
}
