package com.girafi.waddles.entity;

import com.girafi.waddles.Waddles;
import com.girafi.waddles.utils.ConfigurationHandler;
import com.girafi.waddles.utils.WaddlesSounds;
import com.google.common.collect.Sets;
import net.minecraft.entity.EntityAgeable;
import net.minecraft.entity.SharedMonsterAttributes;
import net.minecraft.entity.ai.*;
import net.minecraft.entity.monster.EntityPolarBear;
import net.minecraft.entity.passive.EntityAnimal;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Items;
import net.minecraft.item.Item;
import net.minecraft.item.ItemFishFood.FishType;
import net.minecraft.item.ItemStack;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.SoundEvent;
import net.minecraft.world.World;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.util.Set;

public class EntityAdeliePenguin extends EntityAnimal {
    private static final Set<Item> TEMPTATION_ITEMS = Sets.newHashSet(new ItemStack(Items.field_151115_aP, 1, FishType.COD.func_150976_a()).func_77973_b(), new ItemStack(Items.field_151115_aP, 1, FishType.SALMON.func_150976_a()).func_77973_b());
    public short rotationFlipper;
    private boolean moveFlipper = false;

    public EntityAdeliePenguin(World world) {
        super(world);
        this.func_70105_a(0.4F, 0.95F);
    }

    @Override
    protected void func_184651_r() {
        this.field_70714_bg.func_75776_a(0, new EntityAISwimming(this));
        this.field_70714_bg.func_75776_a(1, new EntityAIExtinguishFire());
        this.field_70714_bg.func_75776_a(2, new EntityAIPanic(this, 1.5D));
        this.field_70714_bg.func_75776_a(3, new EntityAIMate(this, 0.8D));
        this.field_70714_bg.func_75776_a(4, new EntityAIAvoidEntity<>(this, EntityPolarBear.class, 6.0F, 1.0D, 1.2D));
        this.field_70714_bg.func_75776_a(5, new EntityAITempt(this, 1.0D, false, TEMPTATION_ITEMS));
        this.field_70714_bg.func_75776_a(6, new EntityAIFollowParent(this, 1.1D));
        this.field_70714_bg.func_75776_a(7, new EntityAIWander(this, 1.0D));
        this.field_70714_bg.func_75776_a(8, new EntityAIWatchClosest(this, EntityPlayer.class, 6.0F));
        this.field_70714_bg.func_75776_a(9, new EntityAIWatchClosest(this, EntityAdeliePenguin.class, 6.0F));
        this.field_70714_bg.func_75776_a(10, new EntityAILookIdle(this));
    }

    @Override
    protected void func_110147_ax() {
        super.func_110147_ax();
        this.func_110148_a(SharedMonsterAttributes.field_111267_a).func_111128_a(8.0D);
        this.func_110148_a(SharedMonsterAttributes.field_111263_d).func_111128_a(0.16D);
    }

    @Override
    protected SoundEvent func_184639_G() {
        return this.func_70631_g_() ? WaddlesSounds.ADELIE_BABY_AMBIENT : WaddlesSounds.ADELIE_AMBIENT;
    }

    @Override
    protected SoundEvent func_184601_bQ() {
        return WaddlesSounds.ADELIE_HURT;
    }

    @Override
    protected SoundEvent func_184615_bR() {
        return WaddlesSounds.ADELIE_DEATH;
    }

    @Override
    public void func_70636_d() {
        super.func_70636_d();
        if (field_70170_p.field_72995_K) {
            if (this.field_70161_v != this.field_70166_s) {
                if (moveFlipper) {
                    rotationFlipper++;
                }
            }
        }
    }

    @Override
    protected int func_70693_a(EntityPlayer player) {
        if (ConfigurationHandler.dropExp) {
            return super.func_70693_a(player);
        }
        return 0;
    }

    @Override
    public boolean func_70648_aU() {
        return true;
    }

    @Override
    public boolean func_70877_b(@Nullable ItemStack stack) {
        return stack != null && TEMPTATION_ITEMS.contains(stack.func_77973_b());
    }

    @Nullable
    @Override
    public ResourceLocation func_184647_J() {
        if (ConfigurationHandler.dropFish) {
            return Waddles.LOOT_ENTITIES_PENGUIN_FISH;
        }
        return null;
    }

    @Override
    @Nonnull
    public EntityAdeliePenguin func_90011_a(@Nonnull EntityAgeable ageable) {
        return new EntityAdeliePenguin(this.field_70170_p);
    }

    @Override
    public float func_70047_e() {
        return this.func_70631_g_() ? 0.5F : 0.9F;
    }

    private class EntityAIExtinguishFire extends EntityAIPanic {
        EntityAIExtinguishFire() {
            super(EntityAdeliePenguin.this, 2.0D);
        }

        @Override
        public boolean func_75250_a() {
            return (EntityAdeliePenguin.this.func_70631_g_() || EntityAdeliePenguin.this.func_70027_ad()) && super.func_75250_a();
        }
    }
}
